<template>
  <el-col :span="16" :offset="6">
    <el-form label-width="100px" ref="formRef" :model="form">
      <!-- <el-form-item
        label="技术员"
        prop="technicianId"
        style="margin-bottom: 20px"
        :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }"
        v-if="taskDefinitionKey == 'productionSupervisorApprove1'"
      >
        <el-select
          v-model="form.technicianId"
          clearable
          style="width: 100%"
          :filterable="true"
        >
          <el-option
            v-for="item in userOptions"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item> -->
      <el-form-item
        label="审批建议"
        prop="reason"
        style="margin-bottom: 20px"
        :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }"
      >
        <el-input
          type="textarea"
          v-model="form.reason"
          placeholder="请输入审批建议"
        />
      </el-form-item>
    </el-form>
    <div style="margin-left: 10%; margin-bottom: 20px; font-size: 14px">
      <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        @click="handleAudit(1)"
        >通过
      </el-button>
      <!-- <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        v-if="taskDefinitionKey === 'productionSupervisorApprove1'"
        @click="head"
        >指派技术员
      </el-button> -->
      <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="
          !['starter'].includes(
            taskDefinitionKey
          )
        "
        >驳回
      </el-button>

      <el-dropdown @command="(command) => handleCommand(command)" style="margin-left: 30px;">
        <span class="el-dropdown-link">更多<i class="el-icon-arrow-down el-icon--right"></i></span>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item command="cancel">作废</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>

      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleBackList"
        >退回
      </el-button> -->
      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        >不通过
      </el-button>
      <el-button
        icon="el-icon-edit-outline"
        type="primary"
        size="mini"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        @click="handleUpdateAssignee"
        >转办
      </el-button> -->
    </div>
    <head-list ref="headRef" @changeParent="changePersonel"></head-list>
  </el-col>
</template>

<script>
  import {
    updateTech,
    UpdateInformation,
    cancel
  } from '@/api/bpm/components/saleManage/quotation';
  import { approveTaskWithVariables } from '@/api/bpm/task';
  import { listAllUserBind } from '@/api/system/organization';
  import headList from '@/components/headList';
  // 流程实例的详情页，可用于审批
  export default {
    name: '',
    components: {
      headList
    },
    props: {
      businessId: {
        default: ''
      },
      taskId: {
        default: ''
      },
      id: {
        default: ''
      },
      taskDefinitionKey: {
        default: ''
      }
    },
    data() {
      return {
        form: {
          technicianId: '',
          reason: ''
        },
        userOptions: []
      };
    },
    created() {
      this.userOptions = [];
      listAllUserBind().then((data) => {
        this.userOptions.push(...data);
      });
    },
    methods: {
      /** 处理转办审批人 */
      handleUpdateAssignee() {
        this.$emit('handleUpdateAssignee');
      },
      /** 退回 */
      handleBackList() {
        this.$emit('handleBackList');
      },
      head() {
        this.$refs.headRef.open();
      },
      changePersonel(data) {
        this.form.technicianId = data.id;
        this.handleAudit(1, 'zp');
      },
      async handleAudit(status, type) {
        //生产主管审批选择技术员
        // if (this.taskDefinitionKey === 'productionSupervisorApprove1') {
        //   if (!this.form.technicianId && type == 'zp') {
        //     this.$message.warning(`请选择技术人员！`);
        //     return;
        //   }
        // }
        //技术员修改
        // if (this.taskDefinitionKey === 'technicianApprove' && status === 1) {
        //   let data = await this.getTableValue();
        //   if (!arr) {
        //     return;
        //   }
        //   let arr = data.map((item) => {
        //     return {
        //       id: item.id,
        //       technicalAnswerId: item.technicalAnswerId,
        //       technicalAnswerName: item.technicalAnswerName,
        //       technicalDrawings: item.technicalDrawings,
        //       technicalParams: item.technicalParams
        //     };
        //   });
        //   try {
        //     await updateTech(arr);
        //   } catch (error) {}
        // }
        //销售员补充
        if ((this.taskDefinitionKey === 'salesmanApprove'||this.taskDefinitionKey === 'starter')&&status === 1) {
          let arr = await this.getTableValue();
          if (!arr) {
            return;
          }
          let data = await UpdateInformation(arr);
          if (data.code != '0') {
            return;
          }
        }
        this._approveTaskWithVariables(status, this.form.technicianId, type);
      },
      async _approveTaskWithVariables(status, technicianId, type) {
        let variables = {
          pass: !!status
        };
        if (technicianId && type == 'zp') {
          variables['technicianId'] = technicianId;
        }

        approveTaskWithVariables({
          id: this.taskId,
          reason: this.form.reason,
          variables
        }).then((res) => {
          if (res.data.code != '-1') {
            this.$emit('handleAudit', {
              status,
              title: status === 0 ? '驳回' : ''
            });
          }
        });
      },

      getTableValue() {
        return new Promise((resolve, reject) => {
          this.$emit('getTableValue', async (data) => {
            resolve(await data);
          });
        });
      },

      //更多
      handleCommand(command) {
        if (command === 'cancel') {
          this.$confirm("是否确认作废？", {
            type: 'warning',
            cancelButtonText: '取消',
            confirmButtonText: '确定'
          }).then(() => {
            cancel({
              id: this.taskId,
              reason: this.form.reason,
              businessId: this.businessId,
            }).then(() => {
              this.$emit('handleClose');
            }).catch(() => {
              this.$message.error("流程作废失败");
            });
          }).catch(() => {});
        }
      },

    }
  };
</script>

<style lang="scss"></style>
